/* Program skeleton for Problem A (2x2 matrix inversion) */

#include <stdio.h>
#include <stdlib.h>
#include "stdmotif.h"

#ifdef __STDC__     /* diese Funktionsdeklaration gilt in ANSI-C: */
void button_pushed (Widget widget, XtPointer client_data, XtPointer call_data);
#else               /* und diese in Kernighan/Ritchie-C: */
void button_pushed ();
#endif

Widget mw[4];  /* text fields for matrix coefficients: 0,1,2,3 for a,b,c,d */

/************************* MAIN PROGRAM **************************/

#ifdef __STDC__     /* dieser Funktionskopf gilt in ANSI-C: */
int main (int argc, char *argv[])
#else               /* und dieser in Kernighan/Ritchie-C: */
int main (argc, argv)
  int argc;
  char *argv[];
#endif
{
  Widget        toplevel, /* aeusseres Fenster */
                manager,  /* Manager fuer square und buttons */
                square,   /* Manager fuer 4 Textfelder */
                buttons,  /* Manager fuer 2 PushButtons */
                invert,   /* PushButton */
                quit;     /* PushButton */
  XtAppContext  app;
  XmString 	invertlabel, quitlabel;
  int           i;

  /*---------- 1. initialize X and Motif --------------------------------*/
  /* (already complete, should not be changed) */
  globalInitialize ("A");
  toplevel = XtVaAppInitialize (&app, "Hello", NULL, 0,
        &argc, argv, fallbacks, NULL);

  /*---------- 2. create and configure widgets --------------------------*/

  /* Erzeuge vertikalen RowColumn manager 'manager' mit parent 'toplevel'; */
  /* Erzeuge horizontalen 2-spaltigen RowColumn manager 'square' mit  */
  /*   Equalisierung und parent 'manager'; */
  /* Erzeuge horizontalen RowColumn manager 'buttons' mit parent 'manager'; */
  /* Erzeuge TextField widgets mw[0..3] mit je 100 Pixel Breite */
  /*   fuer die Koeffizienten a, b, c, d der Matrix; */
  /* Erzeuge PushButton 'invert' mit Label "Invert matrix" und */
  /*   parent 'buttons'; */
  /* Erzeuge PushButton 'quit' mit Label "Quit"; */

  /*---------- 3. register callback functions ---------------------------*/

  /* Registriere callback-Funktion 'button_pushed' fuer den 'invert' Knopf */
  /*   mit der Zahl 1 als 'client_data'; */
  /* Registriere callback-Funktion 'button_pushed' fuer den 'quit' Knopf */
  /*   mit der Zahl 99 als 'client_data'; */

  /*---------- 4. realize widgets and turn control to X event loop ------*/
  /* (already complete, should not be changed) */
  XtRealizeWidget (toplevel);
  XtAppMainLoop (app);
  return (0);
}

/************************* Functions *************************/

#ifdef __STDC__     /* dieser Funktionskopf gilt in ANSI-C: */
void button_pushed (Widget widget, XtPointer client_data, XtPointer call_data)
#else               /* und dieser in Kernighan/Ritchie-C: */
void button_pushed (widget, client_data, call_data)
  Widget widget;
  XtPointer client_data;
  XtPointer call_data;
#endif
{
  /* dies ist die callback-Funktion, die bei Anklicken der PushButtons
     aufgerufen werden soll */
  double mat[4], new[4], /* alte und neue Matrixkoeffizienten */
         det;            /* Determinante */
  String s;
  int    i;

  /* IF client_data zeigt Knopf 'quit' an */
  /* THEN */
  /*    'exit' aufrufen */
  /* ELSIF client_data zeigt Knopf 'invert' an */
  /* THEN */
  /*    Werte mat[0] bis mat[3] aus widgets mw[0] bis mw[3] auslesen; */
  /*    Determinante  det = mat[0]*mat[3] - mat[1]*mat[2]  ausrechnen; */
  /*    IF Determinante ungleich null */
  /*    THEN */
  /*       Koeffizienten new[0] bis new[3] der invertierten Matrix */
  /*          ausrechnen als */
  /*          new[0] = mat[3]/det; new[1] = -mat[1]/det; */
  /*          new[2] = -mat[2]/det; new[3] = mat[0]/det; */
  /*       Neue Koeffizienten in die widgets mw[0] bis mw[3] mit */
  /*          8 Stellen Breite (2 Nachkommastellen)  eintragen; */
  /*    ELSE */
  /*       "Matrix cannot be inverted" mittels matrixErrorMessage ausgeben; */
  /*    FI */
  /* FI */
}

