/* Program skeleton for Problem B (File Browser) */

#include <stdio.h>
#include <stdlib.h>
#include "stdmotif.h"

Widget toplevel;

/************************* Functions *************************/

void handle_menu (Widget widget, XtPointer client_data, XtPointer call_data)
{
  if ((int)client_data == 0) {  /* first menu entry selected */
    Widget fs = XmCreateFileSelectorDialog (toplevel, "fileselection");
    XtAddCallbackF (fs, XmCokCallback, keepSelectedFile, NULL);
    XtManageChild (fs);
  }
  else if ((int)client_data == 1) {  /* second menu entry selected */
    Widget scrolltext = XmCreateScrolledTextWindow (selectedFile(), toplevel, 
                                                    25, 80);
    XtSetStringValue (scrolltext, XmCvalue, readWholeFile (selectedFile()));
  }
  else if ((int)client_data == 2) {  /* third menu entry selected */
    exit (0);
  }
}

/************************* MAIN PROGRAM **************************/

int main (argc, argv)
  int argc;
  char *argv[];
{
  Widget        main_w, menubar, menu, label;
  XtAppContext  app;

  /********** 1. initialize X and Motif ********************************/
  /* (already complete, need not be changed) */
  toplevel = XtVaAppInitialize (&app, "Hello", NULL, 0,
        &argc, argv, fallbacks, NULL);

  /********** 2. create and configure widgets **************************/
  
  main_w = XmCreateMainWindowWidget ("main_window", toplevel);
  menubar = XmCreateTrivialMenuBar (main_w, "FileBrowser",
                        XmStringCreate ("File Browser", "LARGE"), 'F');
  label = XmCreateLabelWidget ("by", main_w,
                               XmStringCreate ("by Lutz Prechelt", "SMALL"));
  XtSetWidgetValue (main_w, XmCworkWindow, label);
  menu = XmCreatePulldownMenu3 ("TheMenu", menubar, 0,
                  XmStringCreateLocalized ("Select file"), 'f',
                  XmStringCreateLocalized ("Open selected file"), 'O',
                  XmStringCreateLocalized ("Quit"), 'Q',
                  handle_menu);

  /********** 4. realize widgets and turn control to X event loop ******/
  /* (already complete, need not be changed) */
  XtRealizeWidget (toplevel);
  XtAppMainLoop (app);
  return (0);
}

